# Class HealpixTiling

java.lang.Object
uk.ac.starlink.ttools.cone.HealpixTiling

All Implemented Interfaces:
  `SkyTiling`

public class HealpixTiling extends Object implements SkyTiling
Tiling implementation based on the HEALPix scheme.

Since:
  12 Dec 2007
Author:
  Mark Taylor

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`MAX_LEVEL`
Maximum healpix level permitted by CDS Healpix implementation (29).

## Constructor Summary

Constructors
Constructor
Description
`HealpixTiling(int k, boolean nest)`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`int`
`getHealpixK()`
Returns the HEALpix level.
`uk.ac.starlink.table.ValueInfo`
`getIndexInfo()`
Returns a metadata item suitable for describing the pixel index used by this tiling.
`long`
`getPixelCount()`
Returns the total number of tiles in this tiling.
`long`
`getPositionTile(double ra, double dec)`
Returns the index of the tile in which a given sky position falls.
`long[]`
`getTileRange(double ra, double dec, double radius)`
Returns the bounds of a range of pixels which is known to cover a given cone on the sky.
`boolean`
`isNest()`
Indicates HEALPix ordering scheme.

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### MAX_LEVEL

public static final int MAX_LEVEL
Maximum healpix level permitted by CDS Healpix implementation (29).

See Also:
  - Constant Field Values

## Constructor Details

### HealpixTiling

public HealpixTiling(int k, boolean nest)
Constructor.

Parameters:
  `k` - Healpix level
  `nest` - true for nesting scheme, false for ring scheme

## Method Details

### getHealpixK

public int getHealpixK()
Returns the HEALpix level.

Returns:
  log2(nside)

### isNest

public boolean isNest()
Indicates HEALPix ordering scheme.

Returns:
  true for NEST, false for RING

### getPixelCount

public long getPixelCount()
Description copied from interface: `SkyTiling`
Returns the total number of tiles in this tiling. Tile indices are assumed to be in the range from zero (inclusive) to this value (exclusive), so the returned value is one greater than the maximum tile index.

Specified by:
  `getPixelCount` in interface `SkyTiling`
Returns:
  pixel count

### getIndexInfo

public uk.ac.starlink.table.ValueInfo getIndexInfo()
Description copied from interface: `SkyTiling`
Returns a metadata item suitable for describing the pixel index used by this tiling.

Specified by:
  `getIndexInfo` in interface `SkyTiling`
Returns:
  tile index metadata

### getPositionTile

public long getPositionTile(double ra, double dec)
Description copied from interface: `SkyTiling`
Returns the index of the tile in which a given sky position falls.

Specified by:
  `getPositionTile` in interface `SkyTiling`
Parameters:
  `ra` - right ascension in degrees
  `dec` - declination in degrees
Returns:
  tile index for position

### getTileRange

public long[] getTileRange(double ra, double dec, double radius)
Description copied from interface: `SkyTiling`
Returns the bounds of a range of pixels which is known to cover a given cone on the sky. The return value is a two-element array, (lo,hi). Every point in the specified cone must have a tile index which is greater than or equal to the first element of that array, and less than or equal to the second element. If the question cannot be answered, or if the range is thought to be too large to be of use (for instance, if it would take a long time to calculate), then `null` may be returned.

Specified by:
  `getTileRange` in interface `SkyTiling`
Parameters:
  `ra` - right ascension in degrees
  `dec` - declination in degrees
  `radius` - radius in degrees
Returns:
  2-element array giving inclusive (low, high) bounds of tile range covering the cone